#!/bin/sh
#
# Regina - A Normal Surface Theory Calculator
# Tab Conversion Utility
#
# Copyright (c) 1999-2013, Ben Burton
# For further details contact Ben Burton (bab@debian.org).
#
# Usage: replacetabs <text-file> [ <text-file> ... ]
#
# Replaces each tab with four spaces in the given files.
#
# Requires: awk, diff
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# As an exception, when this program is distributed through (i) the
# App Store by Apple Inc.; (ii) the Mac App Store by Apple Inc.; or
# (iii) Google Play by Google Inc., then that store may impose any
# digital rights management, device limits and/or redistribution
# restrictions that are required by its terms of service.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the Free
# Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
# MA 02110-1301, USA.
#
set -e

# Command-line sanity check.
if [ -z "$1" ]; then
    echo "Usage: replacetabs <text-file> [ <text-file> ... ]"
    exit 1
fi

for srcfile
    do tmpfile=$srcfile.tabs.tmp
    if (awk '{gsub("\t", "    "); print }' $srcfile > $tmpfile); then
        if ! diff $srcfile $tmpfile > /dev/null; then
            if (test -s $tmpfile); then
                mv $tmpfile $srcfile
                echo "$srcfile: Tabs replaced"
            else
                rm $tmpfile
                echo "$srcfile: *** FAILURE ***"
            fi
        else
            rm $tmpfile
            # echo "$srcfile: Unchanged"
        fi
    else
        rm $tmpfile
        echo "$srcfile: *** FAILURE ***"
    fi
done
